package com.bwie.auth.factory;

import com.bwie.auth.feign.UserServiceFeign;
import com.bwie.common.domain.User;
import com.bwie.common.result.Result;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class UserServiceFactory implements FallbackFactory<UserServiceFeign> {
    @Override
    public UserServiceFeign create(Throwable cause) {
        return new UserServiceFeign() {
            @Override
            public Result<User> selUser(User user) {
                return Result.error(cause.getMessage());
            }
        };
    }
}
