package com.bwie.common.restController;


import com.bwie.common.result.Result;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import javax.xml.crypto.MarshalException;

@Component
@RestControllerAdvice
@Log4j2
public class ControllerAdvice {


    @ExceptionHandler(MarshalException.class)
    public Result ControllerAdvice(Throwable throwable){
        StackTraceElement traceElement = throwable.getStackTrace()[0];
        String methodName = traceElement.getMethodName();
        String className = traceElement.getClassName();
        int lineNumber = traceElement.getLineNumber();
        log.info(methodName,className,lineNumber+"报错");
        return Result.success(methodName+className+lineNumber+"异常,联系管理员");
    }

}
