package com.bwie.mq.consumer;

import com.bwie.common.utils.TelSmsUtils;
import com.rabbitmq.client.Channel;
import lombok.Data;
import lombok.extern.log4j.Log4j2;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.HashMap;

@Component
@Log4j2
public class BackConsumer {
    @Resource
    private StringRedisTemplate stringRedisTemplate;


    @RabbitListener(queuesToDeclare = @Queue(name = "BackSendSms"))
    public void sengSms(String userPhone, Message message, Channel channel){
        String messageId = message.getMessageProperties().getMessageId();
        Long add = stringRedisTemplate.opsForSet().add("messageId", messageId);
        if (add>0){
            HashMap<String, String> map = new HashMap<>();
            map.put("通知","驳回");
            String s = TelSmsUtils.sendSms(userPhone, "通知", map);
            log.info(s);
        }
        try {
            channel.basicAck(message.getMessageProperties().getDeliveryTag(),true);
        } catch (IOException e) {
            try {
                channel.basicReject(message.getMessageProperties().getDeliveryTag(),false);
                stringRedisTemplate.opsForSet().remove("messageId");
            } catch (IOException ex) {
                throw new RuntimeException(ex);
            }
        }
        log.info("MQ消费成功");
    }
}
