package com.bwie.post.scheduling;

import com.alibaba.fastjson.JSON;
import com.bwie.common.domain.response.PostVo;
import com.bwie.post.mapper.PostMapper;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;


@Component
@Log4j2
public class PostScheduling {

    @Autowired
   private PostMapper postMapper;

    @Scheduled(cron = "0 0/1 * * * ?")
    public void PostScheduling(){
        log.info("定时器开始运行,查询过期招聘中");
        List<PostVo> list = postMapper.selPostOverdue();
        log.info("查询过期招聘信息为:{}", JSON.toJSONString(list));
        for (PostVo postVo : list) {
            postMapper.updPostShow(postVo.getPostId());
            log.info("逻辑删除招聘岗位:{}"+postVo.getPostName());
        }
        log.info("定时器运行完成");
    }
}
